# UniTerm Integration Example Application

This is a minimal application used to demonstrate how
to integrate with the UniTerm Framework.

## Points of interest

The main point of interest is the `TransRunner` object.
This will call the UniTerm processing function `uniterm_run_trans`
to run an action with UniTerm. It also polls for status and allows
cancellation.

Also, the `SaleViewController` has a function to change the server
configuration UniTerm will connect to. This uses the `uniterm_modify_config`
function.

## Setup

You will need to drag and drop the uniterm.framework and uniterm.bundle
objects into the project. These are not bundled with the example code
because the example will work with both device and simulator builds
of the framework.

### Verify framework embedding

The framework will need to be embedded into the app when built.
This should already be configured but you will need to verify and
may need to add.

Go to the project settings, and choose the target. Go to General.
At the bottom is a section "Frameworks, Libraries, and Embedded Content".
Ensure uniterm.framework is listed here. If not add it.

In "Build Phases" ensure unterm.framework is also listed under "Embed
Frameworks".

## Changing the host

The uniterm.bundle includes a uniterm.ini file which is the default
configuration. The host and port for the payment server can be changed
here for your testing. It is recommended to set the payment server
in this file. While you can deploy and use `uniterm_modify_config`
it is typically smoother to set the payment server by editing the
uniterm.ini in the uniterm.bundle.

The ini as read from the bundle is updated when the version number changes.
During development, when working with Xcode, running the app on a device
(or simulator) then changing the ini and running again will not update the ini
data for the installed app. Due to the version number not having changed.
Uninstalling the app and running again so it's reinstalled will allow the
change to apply.

## Running a sale transaction

The example has the payment device information hard coded in the
`doSubmitPayment` function in SaleViewController.m. If using
a different device or different connectivity this needs to be
changed. Specifically, the `u_device` and `u_devicetype` parameters.

